#pragma once

// CGraph

struct GraphMarker {
	GraphMarker( double nValue_, COLORREF clrColor_ )
	{
		nType = 1;
		nValue = nValue_;
		clrColor = clrColor_;
	}
	GraphMarker()
	{
		nType = 0;
	}

	int nType;
	double nValue;
	COLORREF clrColor;
};

class CGraph : public CWnd
{
	DECLARE_DYNAMIC(CGraph)

	CArray	<int, int> m_arrData;
	int	m_nWidth;
	int m_nMin;
	int m_nMax;
	int m_nPos;
	COLORREF m_clrLine;
	COLORREF m_clrBack;
	int m_nDCWidth;
	int m_nDCHeight;
	CDC m_dcBuffer;
	CBitmap  m_bmpBuffer;

	int m_nStatRMS;
	int m_nType;
	CArray <GraphMarker, GraphMarker> m_arrMarkers;

	BOOL m_bInvert;

public:
	CGraph();
	virtual ~CGraph();
	BOOL RegisterWindowClass();

	void Setup(int nWidth, int nMin, int nMax, COLORREF clrBack, COLORREF clrLine, int nType = 1);

	void AddValue(int nValue);
	CPoint GetPoint( int n );
	int GetValue( int nVal );
	
	static COLORREF ColorMid( COLORREF a, COLORREF b, int l );
	static COLORREF ColorDelta( COLORREF clr, int r, int g, int b );
	FLOAT *ComputeFourier();


protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnPaint();
};


