// MultiGraph.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "MultiGraph.h"

#define GRAPH_CLASSNAME    _T("MultiGraphCtrl")  // Window class name

// CMultiGraph

IMPLEMENT_DYNAMIC(CMultiGraph, CWnd)

CMultiGraph::CMultiGraph()
{
	RegisterWindowClass();
	m_lpCurrentLayer = NULL;
	m_nLimit = -1;
}

CMultiGraph::~CMultiGraph()
{
	int i;

	for (i=0; i<m_arrLayers.GetSize(); i++)
		delete m_arrLayers[i];

	m_arrLayers.RemoveAll();
}

BOOL CMultiGraph::RegisterWindowClass()
{
    WNDCLASS wndcls;
    HINSTANCE hInst = AfxGetInstanceHandle();

    if (!(::GetClassInfo(hInst, GRAPH_CLASSNAME, &wndcls)))
    {
        // otherwise we need to register a new class

        wndcls.style            = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
        wndcls.lpfnWndProc      = ::DefWindowProc;
        wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
        wndcls.hInstance        = hInst;
        wndcls.hIcon            = NULL;
        wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        wndcls.hbrBackground    = (HBRUSH) (COLOR_3DFACE + 1);
        wndcls.lpszMenuName     = NULL;
        wndcls.lpszClassName    = GRAPH_CLASSNAME;

        if (!AfxRegisterClass(&wndcls))
        {
            AfxThrowResourceException();
            return FALSE;
        }
    }

    return TRUE;
}



BEGIN_MESSAGE_MAP(CMultiGraph, CWnd)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()



// CMultiGraph message handlers



void CMultiGraph::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CWnd::OnPaint() for painting messages
	int i;
	CRect rcRect;
	GetClientRect( &rcRect );
	CRect rcSub = rcRect;

	COLORREF clrDelta = CGraph::ColorDelta( m_clrBack, -20, -20, 0 );
	for ( i = rcRect.top; i < rcRect.bottom; i+=2 )
	{
		CBrush myBrush( CGraph::ColorMid( m_clrBack, clrDelta, i*255/rcRect.bottom ) );
		rcSub.top = i;
		rcSub.bottom = i+20;
		dc.FillRect( rcSub, &myBrush );
	}


	for (i=0; i<m_arrLayers.GetSize(); i++)
	{
		Paint( rcRect, &dc, i );
	}
}

BOOL CMultiGraph::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default
	return FALSE;
	return CWnd::OnEraseBkgnd(pDC);
}
