// SerialComm.h: interface for the CSerialComm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_)
#define AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//#define EMULUJEME

#include <math.h>


class CSerialComm  
{
	HANDLE hCom;
	CFile	m_fRecord;
	CFile	m_fPlay;

public:
	CSerialComm()
	{
		hCom = NULL;
	}
	virtual ~CSerialComm()
	{
		if (hCom != NULL)
			CloseHandle(hCom);
	}

	CString strInternal;	// toto je nas demo buffer
	
	void Close()
	{
		if (hCom != NULL)
			CloseHandle(hCom);
		hCom = NULL;
	}

	BOOL IsValid()
	{
		//return TRUE;
		if ( IsPlaying() )
			return TRUE;
		return (hCom != NULL && hCom != INVALID_HANDLE_VALUE) ? TRUE : FALSE;
	}

	void Send( CString strString )
	{
		int i;
#ifdef EMULUJEME
		strInternal += strString;
#else
		char Buffer[1024];
		for (i=0; i < strString.GetLength(); i++)
			Buffer[i] = (char)strString[i];
		Buffer[i] = 0;

	  DWORD Pocet=strString.GetLength();

	  WriteFile(
				hCom,   // Handle portu, ktory ste otvorili CreateFile
				&Buffer,  // Smernik (pointer) na data, ktore chcem vysielat
				Pocet,      // Pocet bytov, ktore chcem vyslat
				&Pocet, // Smernik (pointer) na pocet vyslanych dat
				NULL);  // Musi byt NULL

	  if( Pocet != strString.GetLength() ) // Ak pocet prenesenych dat nesuhlasi    
	  {
		  MessageBox(NULL, _T("Chyba:  Nepodaril sa odoslat buffer."), _T("Chyba"), 0);
		  Close();
	  }

#endif
	}

	BOOL Receive( CString &strString )
	{
		int i;
		if ( IsPlaying() )
			return EmulatePlaying( strString );

#ifdef EMULUJEME
		if (strInternal.IsEmpty())
			return FALSE;

		strString = strInternal;

		strInternal = "";
		return TRUE;
#else
	  DWORD Pocet=0;            // Poc(et prijatch dt
	  char Buffer[1024];

	  //PurgeComm(hCom,PURGE_TXCLEAR | PURGE_RXCLEAR);

	  if (!ReadFile(
			   hCom,         // Handle portu, z ktorho c(tame
			   &Buffer,        // Pointer na buffer, kam ukladme prijat dta
			   1024,            // Poc(et bytov, na ktor c(akme
			   &Pocet,           // Pointer na skutoc(n poc(et prijatch dt
			   NULL))        // Mus byt( NULL
		  Close();


							 // Funkcia ReadFile tu teraz c(ak, a km niec(o 
							 // neprde, ale me aj skonc(it( bez zachytenho znaku, 
							 // ak medzitm vypria timeouty.

	  if( Pocet == 0 )      // Ak poc(et prenesench dt neshlas    
		  return FALSE;

	  if ( IsRecording() )
		  m_fRecord.Write( Buffer, Pocet );

	  strString = "";
	  for (i=0; i<(int)Pocet; i++)
		  strString += CString(Buffer[i]);
	  return TRUE;
	  
#endif
	}

	BOOL Init(CString strPort, long nBaud)
	{
 
		  hCom = CreateFile(                 
				 strPort,                         // Nzov portu, ktor otvrame
				 GENERIC_READ | GENERIC_WRITE,    // Otvrame na c(tanie aj na zpis
				 0,                               // Zdiel(anie nebude iadne
				 NULL,                            // Bezpec(nostn info iadne
				 OPEN_EXISTING,                   // Otvrame existujci (port)
				 0,                               // iadne atribty sboru
				 NULL);                           // Mus byt( NULL

		  if ( hCom == INVALID_HANDLE_VALUE )
		  {
			  MessageBox(NULL, _T("Chyba:  Port sa neda otvorit."), _T("Chyba"), 0);
			  return FALSE;
		  }


		 DCB PortDCB;                       // truktra, v ktorej s uloen parametre    
  
		 PortDCB.DCBlength = sizeof(DCB);  // Inicializuj poloku DCBlength
		 GetCommState(hCom,&PortDCB);       // Nac(taj aktulne nastavenia
		 //printf("\nBaud rate:       %d",PortDCB.BaudRate); 

		 PortDCB.BaudRate = nBaud;           // Zmenme nejak parameter v DCB

		 int err;
		 err = SetCommState(hCom,&PortDCB); // Nastav aktulne nastavenia na port
		 if(!err)   
		 {
			 MessageBox(NULL, _T("Chyba:  Port sa neda nakonfigurovat."), _T("Chyba"), 0);
			 return FALSE;
		 }


		 // vypis DCB do strInitInfo
	
		
	COMMTIMEOUTS timeouts;
   
  timeouts.ReadIntervalTimeout         = 10;

  timeouts.ReadTotalTimeoutMultiplier  = 10;
  timeouts.ReadTotalTimeoutConstant    = 10;

  timeouts.WriteTotalTimeoutConstant    = 10;
  timeouts.WriteTotalTimeoutMultiplier	= 10;
  
  
  if (!SetCommTimeouts(hCom,&timeouts))
	  MessageBox(NULL, _T("Nepodarilo sa nastavit timeouty."), _T("Chyba"), 0);
	return FALSE;

	return TRUE;

	
	}


	// recording
	void StartRecording( CString strFile )
	{
		m_fRecord.Open( strFile, CFile::modeCreate | CFile::modeWrite );
	}
	void StopRecording()
	{
		m_fRecord.Close();
	}
	BOOL IsRecording()
	{
		return m_fRecord.m_hFile != INVALID_HANDLE_VALUE;
	}
	CString GetRecordFileName()
	{
		return m_fRecord.GetFilePath();
	}

	// playing
	void StartPlaying( CString strFile )
	{
		m_fPlay.Open( strFile, CFile::modeRead );
	}
	void StopPlaying()
	{
		m_fPlay.Close();
	}
	BOOL IsPlaying()
	{
		return m_fPlay.m_hFile != INVALID_HANDLE_VALUE;
	}
	BOOL EmulatePlaying( CString &strString )
	{
		static char chBuff[1024];
		static LONG s_lTime = 0;

		if (s_lTime == 0)
		{
			s_lTime = GetTickCount();
			strString.Empty();
			return TRUE;
		}
		LONG lPassed = GetTickCount() - s_lTime;
		s_lTime = GetTickCount();
#define BYTESPERSEC 600
//#define BYTESPERSEC 60
		//600
		int nPushBuffer = lPassed * BYTESPERSEC / 1000;	// 600 samples per second
		nPushBuffer -= nPushBuffer & 1;	// iba parny pocet bajtov
		lPassed -= nPushBuffer * 1000 / BYTESPERSEC;
		s_lTime -= lPassed;

		if (nPushBuffer > 1024)
			nPushBuffer = 1024;
		int nRead = m_fPlay.Read( chBuff, nPushBuffer );
		if ( nRead != nPushBuffer )
			m_fPlay.SeekToBegin();

	  strString = "";
	  for (int i=0; i<nRead; i++)
		  strString += CString(chBuff[i]);

//		strString = CString( chBuff, nRead );
		return TRUE;
	}

};

#endif // !defined(AFX_SERIALCOMM_H__D0A10092_8DEF_400E_920C_81292952B552__INCLUDED_)
