// Tab.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "Tab.h"

#include "TabFourier.h"
#include "TabPulse.h"
#include "TabStat.h"
// CTab

IMPLEMENT_DYNAMIC(CTab, CTabCtrl)

CTab::CTab()
{
   m_nPageCount = 0;
}

CTab::~CTab()
{
	for (int i=0; i<m_nPageCount; i++)
		delete m_Dialog[i];
}

void CTab::AddTab( CTabDialog *lpDlg )
{
	m_Dialog[m_nPageCount] = lpDlg;
	m_DialogID[m_nPageCount] = lpDlg->GetIDD();
	InsertItem(m_nPageCount, lpDlg->GetName());
	m_nPageCount++;
}

BEGIN_MESSAGE_MAP(CTab, CTabCtrl)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, &CTab::OnTcnSelchange)
END_MESSAGE_MAP()

//This function creates the Dialog boxes once
void CTab::InitDialogs()
{
	for (int i=0; i<m_nPageCount; i++)
		m_Dialog[i]->Create(m_DialogID[i],GetParent());
}

// CTab message handlers



void CTab::OnTcnSelchange(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	ActivateTabDialogs();
	*pResult = 0;
}

void CTab::ActivateTabDialogs()
{
  int nSel = GetCurSel();

  if(m_Dialog[nSel]->m_hWnd)
     m_Dialog[nSel]->ShowWindow(SW_HIDE);

  CRect l_rectClient;
  CRect l_rectWnd;

  GetClientRect( l_rectClient );
  AdjustRect( FALSE, l_rectClient );
  
  GetWindowRect( l_rectWnd );
  GetParent()->ScreenToClient( l_rectWnd );

  l_rectClient.OffsetRect( l_rectWnd.left, l_rectWnd.top );

  for(int nCount=0; nCount < m_nPageCount; nCount++)
  {
     m_Dialog[nCount]->SetWindowPos(&wndTop, 
		 l_rectClient.left, l_rectClient.top, l_rectClient.Width(), l_rectClient.Height(), 
		 SWP_HIDEWINDOW);
  }
  m_Dialog[nSel]->SetWindowPos(&wndTop, l_rectClient.left, l_rectClient.top, l_rectClient.Width(), l_rectClient.Height(), SWP_SHOWWINDOW);

  m_Dialog[nSel]->ShowWindow(SW_SHOW);
}

void CTab::ValueHandler( int nVal )
{
	for (int i=0; i<m_nPageCount; i++)
		((CTabDialog *)m_Dialog[i])->ValueHandler( nVal );
}

void CTab::ReceiveHandler()
{
	for (int i=0; i<m_nPageCount; i++)
		((CTabDialog *)m_Dialog[i])->ReceiveHandler();
}
