// TabFourier.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "TabFourier.h"
#include "ECGDlg.h"

// CTabFourier dialog

IMPLEMENT_DYNAMIC(CTabFourier, CDialog)

CTabFourier::CTabFourier(CWnd* pParent /*=NULL*/)
	: CTabDialog(CTabFourier::IDD, pParent)
	, m_nZoom(0)
	, m_bZoom(FALSE)
{

}

CTabFourier::~CTabFourier()
{
}

void CTabFourier::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CUSTOM3, m_wndFourier);
	DDX_Check(pDX, IDC_CHECK1, m_bZoom);
}


BEGIN_MESSAGE_MAP(CTabFourier, CDialog)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CTabFourier message handlers

BOOL CTabFourier::OnInitDialog()
{
	CTabDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	SetTimer(0, 1000, NULL );
	m_wndFourier.Setup( 512, 0, 512, GetSysColor(15), 0xff00, 0 );

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTabFourier::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if ( !IsWindowVisible() )
		return;

	m_lpECGDlg->ComputeFourier();

	FLOAT *fArr = m_lpECGDlg->m_ECGData.m_fFourier;

	int nCount = 512;
	UpdateData();
	FLOAT fMul = 4.0;
	if ( m_bZoom )
	{
		nCount /= 4;
		fMul *= 4.0;
	}
	m_wndFourier.m_nWidth = nCount;

	m_wndFourier.m_nPos = 0;
	for (int j=0; j<nCount*2; j+=2)
	{
		FLOAT fVal = fArr[j]*fArr[j] + fArr[j+1]*fArr[j+1];
		fVal = sqrt( fVal );
		m_wndFourier.AddValue( m_wndFourier.m_nMax-fVal*4 );
	}

	DOUBLE dbBpm = m_lpECGDlg->m_ECGData.m_dbSamples;
	m_wndFourier.m_arrMarkers.SetAtGrow(0, GraphMarker( (50.0/dbBpm) * fMul * m_wndFourier.m_nWidth , 0xFF8080 ) );
	m_wndFourier.m_arrMarkers.SetAtGrow(1, GraphMarker( (100.0/dbBpm) * fMul * m_wndFourier.m_nWidth , 0xFFb0b0 ) );
	m_wndFourier.m_arrMarkers.SetAtGrow(2, GraphMarker( (1.0/dbBpm) * fMul * m_wndFourier.m_nWidth , 0xD0b020 ) );
	m_wndFourier.m_arrMarkers.SetAtGrow(3, GraphMarker( (10.0/dbBpm) * fMul * m_wndFourier.m_nWidth , 0xD0b020 ) );

	//CRect rcGraph;
//	m_wndFourier.GetClientRect( rcGraph );
//	m_wndFourier.ClientToScreen( rcGraph );
	m_wndFourier.InvalidateRect( NULL, FALSE );

	CTabDialog::OnTimer(nIDEvent);
}
