// TabMain.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "TabMain.h"
#include "ECGDlg.h"

// CTabMain dialog

IMPLEMENT_DYNAMIC(CTabMain, CDialog)

CTabMain::CTabMain(CWnd* pParent /*=NULL*/)
	: CTabDialog(CTabMain::IDD, pParent)
	, m_strPort(_T("COM4:"))
	, m_bTurbo(FALSE)
{

}

CTabMain::~CTabMain()
{
}

void CTabMain::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_strPort);
	DDX_Control(pDX, IDC_COMBO2, m_ctrlBaud);
	DDX_Control(pDX, IDC_BUTTON4, m_btnStart);
	DDX_Check(pDX, IDC_CHECK1, m_bTurbo);
}


BEGIN_MESSAGE_MAP(CTabMain, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, &CTabMain::OnRecord)
	ON_BN_CLICKED(IDC_BUTTON3, &CTabMain::OnPlay)
	ON_BN_CLICKED(IDC_BUTTON4, &CTabMain::OnStart)
	ON_BN_CLICKED(IDC_CHECK1, &CTabMain::OnTurbo)
	ON_BN_CLICKED(IDC_BUTTON2, &CTabMain::OnModulate)
END_MESSAGE_MAP()


// CTabMain message handlers

void CTabMain::OnRecord()
{
	// TODO: Add your control notification handler code here
	if ( m_lpECGDlg->m_comm.IsRecording() )
		return;

	m_lpECGDlg->m_comm.StartRecording(_T("temp.dat"));
}

void CTabMain::OnPlay()
{
	// TODO: Add your control notification handler code here
	if ( m_lpECGDlg->m_comm.IsPlaying() )
		return;

	CString strFilter = _T("BIN Files (*.bin)|*.bin|*.dat|All Files (*.*)|*.*||");
	CFileDialog FileDlg(TRUE, _T(".bin"), NULL, 0, strFilter, this);
	if( FileDlg.DoModal() == IDOK )
	{
		CString strNewName = FileDlg.GetPathName();
		m_lpECGDlg->m_comm.StartPlaying( strNewName );
		m_btnStart.SetWindowTextW( _T("Stop") );
	}
}

void CTabMain::OnStart()
{
	if ( !m_lpECGDlg->m_comm.IsValid() && 
		 !m_lpECGDlg->m_comm.IsPlaying() && 
		 !m_lpECGDlg->m_comm.IsRecording() )
	{
		UpdateData( TRUE );

		CString strStatus;
		strStatus.Format( _T("Opening port...") );
		m_lpECGDlg->m_wndBar.SetPaneText(0, strStatus);

		CString strBaud;
		m_ctrlBaud.GetWindowTextW(strBaud);
		int nBaud = _ttoi( strBaud );
		if ( m_lpECGDlg->m_comm.Init( m_strPort, nBaud ) )
			m_btnStart.SetWindowTextW( _T("Stop") );
	} else 
	{
		CString strStatus;
		strStatus.Format( _T("Closing port...") );
		m_lpECGDlg->m_wndBar.SetPaneText(0, strStatus);
		if ( m_fModulate.m_hFile != INVALID_HANDLE_VALUE )
		{
			m_fModulate.Close();
		}

		if ( m_lpECGDlg->m_comm.IsPlaying() )
		{
			m_lpECGDlg->m_comm.StopPlaying();
		}

		if ( m_lpECGDlg->m_comm.IsRecording() )
		{
			m_lpECGDlg->m_comm.Close();

			CString strFilter = _T("BIN Files (*.bin)|*.bin|*.dat|All Files (*.*)|*.*||");
			CFileDialog FileDlg(FALSE, _T(".bin"), NULL, 0, strFilter, this);
			if( FileDlg.DoModal() == IDOK )
			{
				CString strNewName = FileDlg.GetPathName();
				CString strOldName = m_lpECGDlg->m_comm.GetRecordFileName(); 

				m_lpECGDlg->m_comm.StopRecording();

				CopyFile( strOldName, strNewName, FALSE );
				DeleteFile( strOldName );
			}
		}
		m_lpECGDlg->m_comm.Close();
		m_btnStart.SetWindowTextW( _T("Start") );
	}
}

BOOL CTabMain::OnInitDialog()
{
	CTabDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	m_ctrlBaud.SetCurSel(1);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTabMain::OnTurbo()
{
	UpdateData( TRUE );
	if ( m_bTurbo )
		m_lpECGDlg->m_comm.Send( _T("\xAAs") );
	else
		m_lpECGDlg->m_comm.Send( _T("\xAAz") );
}

void CTabMain::OnModulate()
{
	// TODO: Add your control notification handler code here
	CString strFilter = _T("SAM Files (*.sam)|*.sam|*.dat|All Files (*.*)|*.*||");
	CFileDialog FileDlg(FALSE, _T(".sam"), NULL, 0, strFilter, this);
	if( FileDlg.DoModal() == IDOK )
	{
		m_fModulate.Open( FileDlg.GetPathName(), CFile::modeWrite | CFile::modeCreate );
	}
}

#define MODULATOR_SAMPLES 300
#define MODULATOR_RATE 44100
#define MODULATOR_FREQ 4000
void CTabMain::ValueHandler( int nVal )
{
	static FLOAT fPhase = 0;
	if ( m_fModulate.m_hFile == INVALID_HANDLE_VALUE )
		return;

	// get time of sample : 300 samples per second
	for (int i=0; i<MODULATOR_RATE / MODULATOR_SAMPLES; i++)
	{
		//fPhase += 6.28*MODULATOR_FREQ/MODULATOR_RATE;
		//FLOAT fSample = (sin(fPhase))*nVal;		// 0..4096
		//fSample *= 8;	// 32768
		//WORD wSample = (WORD) fSample;
		//m_fModulate.Write( &wSample, 2 );
		WORD wSample0 = 8*nVal;
		WORD wSample1 = (WORD)(-8*nVal);
		m_fModulate.Write( &wSample0, 2 );
		m_fModulate.Write( &wSample0, 2 );
	}
}
