// TabPulse.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "TabPulse.h"
#include "ECGDlg.h"


//#pragma comment(lib, "winmm.lib")

//using namespace jdkmidi;


UINT CTabPulse::ThreadFunc(LPVOID lParam)
{
	CTabPulse *lpPulse = (CTabPulse *)lParam;
	/*
	jdkmidi::MIDITimedBigMessage msgFirst;
	jdkmidi::MIDITimedBigMessage msgClock;
	msgFirst.SetStatus(jdkmidi::START);
	msgClock.SetStatus(jdkmidi::TIMING_CLOCK);
	*/
	BOOL bFirst = TRUE;

	int nLast = -1;
	int nTotalPulses = 0;

	while (1)
	{
		LONG lTime = GetTickCount();
		if ( lpPulse->m_lNotifyTime == 0 )
		{
			Sleep(5);
			continue;
		}
		if (bFirst)
		{
			bFirst = FALSE;
	//		lpPulse->m_Midi.OutputMessage( msgFirst );
			//lpPulse->m_Midi.OutputMessage( msgClock );
			nTotalPulses = 0;
		}
/*
		int nCounter = (GetTickCount()-lpPulse->m_lNotifyTime)*24/lpPulse->m_lNotifyLength;
		Sleep(5);
		//if (nCounter != nLast && nCounter < 24)
		for (i=nLast; i<max(nCounter-1,24-1); i++)
			lpPulse->m_Midi.OutputMessage( msgClock );
		nLast = nCounter;*/
		// dlzka : m_lNotifyLength;
		/*
		LONG lDestLen = 850;
		LONG lFunDiff = lpPulse->m_lNotifyLength-lDestLen;
		if (lFunDiff > 200)
			lFunDiff = 200;
		if (lFunDiff < 0)
			lFunDiff = 0;*/

		LONG lFunDiff = 0;
		LONG lHoldNotify = lpPulse->m_lNotifyTime-lFunDiff;	// 100 ms in advance :)
		LONG lNotifyLen = lpPulse->m_lNotifyLength;

		lpPulse->m_lNotifyTime = 0;
		int nTicks = 24*1;
		for (int i=1; i<=nTicks; i++)
		{
			LONG lDelta = lHoldNotify - GetTickCount() + i*lNotifyLen/nTicks;
			if (lDelta > 0)
				Sleep(lDelta);
	//		lpPulse->m_Midi.OutputMessage( msgClock );
		}
		if (++nTotalPulses>=7)
			bFirst = TRUE;
			
	}
	//m_lNotifyTime
}


// CTabPulse dialog

IMPLEMENT_DYNAMIC(CTabPulse, CDialog)

CTabPulse::CTabPulse(CWnd* pParent /*=NULL*/)
	: CTabDialog(CTabPulse::IDD, pParent)
	, m_bSkipTop(TRUE)
//	, m_Midi(128)
{
	m_lNotifyTime = 0;
	//CWinThread *pThread = AfxBeginThread( CTabPulse::ThreadFunc, this,
	//	THREAD_PRIORITY_ABOVE_NORMAL, 0, 0 );
}

CTabPulse::~CTabPulse()
{
//	m_Midi.CloseMIDIOutPort();
}

void CTabPulse::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CUSTOM1, m_wndPulse);
	DDX_Check(pDX, IDC_CHECK2, m_bSkipTop);
}


BEGIN_MESSAGE_MAP(CTabPulse, CDialog)
END_MESSAGE_MAP()


// CTabPulse message handlers

BOOL CTabPulse::OnInitDialog()
{
	CTabDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	m_wndPulse.Setup( GetSysColor(15), 10 );
	/*
    m_Midi.StartTimer( 20 );
    m_Midi.OpenMIDIOutPort( 2 );
*/
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTabPulse::ValueHandler( int nVal ) 
{
	static int nLastVal = -1;
	static int nLastLen = -1;
	static int nLastGood = -1;
	static int nLastThis = -1;
	static int nLastThisGood = -1;

	int nValue = nVal;
	ECGData *lpData = &m_lpECGDlg->m_ECGData;

	// total 2048
	if ( nLastVal < lpData->m_nThresh && nValue >= lpData->m_nThresh )
	{
		// m_dbSamples  samples/second;   1000/m_dbSamples => ms per sample
		LONG lRealTime = lpData->m_dwBufferReceivedTime - 
			(int)((lpData->m_nBufferReceivedSize-lpData->m_nBufferReceivedIndex)*1000/lpData->m_dbSamples);
		m_lNotifyLength = (int)(nLastLen*1000/lpData->m_dbSamples); // estimate new peak
		//lRealTime += m_lNotifyLength;
		m_lNotifyTime = lRealTime;
		

		nLastGood = nLastLen;
		nLastLen = 0;
	} else
	{
		nLastLen++;
	}

	nLastVal = nValue;

	if ( nLastLen == (int)(nLastGood*(1.0-0.4)) )
	{
		// Center waveform {{{
		LPMultiGraphLayer lpLayer = m_wndPulse.GetCurrentLayer();
		if ( lpLayer && lpLayer->m_arrData.GetSize() > 100 )
		{
			int nMax = 0;
			FLOAT fMax = lpLayer->m_arrData[0].y;
			for (int i=0; i<lpLayer->m_arrData.GetSize(); i++)
			{
				if ( lpLayer->m_arrData[i].y < fMax )
				{
					fMax = lpLayer->m_arrData[i].y;
					nMax = i;
				}
			}

			FLOAT fDelta = 0.4f - lpLayer->m_arrData[nMax].x;

			//if ( fDelta != 0 )
				for (int i=0; i<lpLayer->m_arrData.GetSize(); i++)
					lpLayer->m_arrData[i].x += fDelta;
		}
		// }}}
		m_wndPulse.NewSeries(0xff, 1);
		nLastThis = 0;
		nLastThisGood = nLastGood;
	}
	if (nLastThis >= 0)
		nLastThis++;

	if ( nLastThisGood > 100 )
	{
		m_wndPulse.AddPoint( (FLOAT)nLastThis/nLastThisGood, 1.0-(FLOAT)nValue/2048.0);
	}
}

void CTabPulse::ReceiveHandler() 
{
	UpdateData();
	m_wndPulse.SkipCurrentLayer( m_bSkipTop );
	InvalidateRect(NULL, FALSE);
}

