// TabTempo.cpp : implementation file
//

#include "stdafx.h"
#include "ECG.h"
#include "TabTempo.h"
#include "ECGDlg.h"
#include <mmsystem.h>
// CTabTempo dialog

IMPLEMENT_DYNAMIC(CTabTempo, CDialog)

CTabTempo::CTabTempo(CWnd* pParent /*=NULL*/)
	: CTabDialog(CTabTempo::IDD, pParent)
	, m_bBeep(TRUE)
{

}

CTabTempo::~CTabTempo()
{
}

void CTabTempo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CUSTOM3, m_wndGraph);
	DDX_Control(pDX, IDC_EDIT1, m_wndBPM);
	DDX_Check(pDX, IDC_CHECK1, m_bBeep);
}


BEGIN_MESSAGE_MAP(CTabTempo, CDialog)
END_MESSAGE_MAP()


BOOL CTabTempo::OnInitDialog()
{
	CTabDialog::OnInitDialog();

	// TODO:  Add extra initialization here
	m_wndGraph.Setup(0, 40, -120, GetSysColor(15), RGB(255, 0, 0) );

	CFont fnt;
	fnt.CreateFont(60, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH, _T("Arial"));

	m_wndBPM.SetFont( &fnt );
	m_wndBPM.SetWindowTextW( _T("") );
	fnt.Detach();

	OutputDebugString(_T("CTabTempo::OnInitDialog()\n"));

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTabTempo::ValueHandler( int nVal )
{
	static int nLastVal = -1;
	static int nLastCount = -1;

	if ( nLastVal == -1 )
		nLastVal = nVal;

	ECGData *lpData = &m_lpECGDlg->m_ECGData;

	// total 2048
	if ( nLastVal < lpData->m_nThresh && nVal >= lpData->m_nThresh )
	{
		//OutputDebugString(lpData->m_strStat);
		if ( lpData->m_strStat.Compare( _T("Valid") ) == 0 )
		{
			//OutputDebugString(_T("playing!\n"));

			UpdateData();
			if ( m_bBeep )
				sndPlaySound(ECGData::g_sndRes, SND_MEMORY | SND_ASYNC); 
		}
		//lpData->m_strThreadPlay = _T("bell");

		CString strBPM;
		FLOAT fBPM = 60.0 / ((FLOAT)nLastCount / lpData->m_dbSamples);
		strBPM.Format( _T("%3.1f"), fBPM );
		m_wndBPM.SetWindowTextW( strBPM );

		if (nLastCount > -1)
			m_wndGraph.AddValue( fBPM );
		
		m_wndGraph.InvalidateRect( NULL, FALSE );

		nLastCount = 0;
	} else
	{
		if (nLastCount > -1)
			nLastCount++;
	}
	nLastVal = nVal;
}
